Imports System.Math
Imports System.IO
Module Calcul
    Public Sub Calcul_Eclairage()
        Dim nblum1 As Double
        'indice du local
        K = (a * b) / (h1 * (a + b))
        'Utilance du local
        Dim ut0, Utt1, Utt2 As Double
        ut0 = Uplaf * 1000 + Umur * 100 + Uplanutile * 10
        Dim ut1() As Double = {0.75, 0.65, 0.55}
        Dim ut3() As Double = {0.85, 0.8, 0.75}
        Dim ut5() As Double = {0.95, 0.9, 0.85}
        Select Case K
            Case Is < 1
                If ut0 > 751 Then
                    Ut = ut1(0)
                ElseIf ut0 > 731 Then
                    Ut = ut1(0) - (((ut1(0) - ut1(1)) / 20) * (751 - ut0))
                ElseIf ut0 > 531 Then
                    Ut = ut1(1) - (((ut1(1) - ut1(2)) / 200) * (731 - ut0))
                Else
                    Ut = (ut1(2) / 531) * ut0
                End If
            Case Is < 3
                If ut0 > 751 Then
                    Ut = ut1(0) + ((ut3(0) - ut1(0)) / 2) * (K - 1)
                ElseIf ut0 > 731 Then
                    Utt1 = ut1(0) + ((ut3(0) - ut1(0)) / 2) * (K - 1)
                    Utt2 = ut1(1) + ((ut3(1) - ut1(1)) / 2) * (K - 1)
                    Ut = Utt2 + (((Utt1 - Utt2) / 20) * (ut0 - 731))
                ElseIf ut0 > 531 Then
                    Utt1 = ut1(1) + ((ut3(1) - ut1(1)) / 2) * (K - 1)
                    Utt2 = ut1(2) + ((ut3(2) - ut1(2)) / 2) * (K - 1)
                    Ut = Utt2 + (((Utt1 - Utt2) / 200) * (ut0 - 531))
                Else
                    Utt1 = ut1(2) + ((ut3(2) - ut1(2)) / 2) * (K - 1)
                    Ut = (Utt1 / 531) * ut0
                End If
            Case Is < 5
                If ut0 > 751 Then
                    Ut = ut3(0) + ((ut5(0) - ut3(0)) / 2) * (K - 3)
                ElseIf ut0 > 731 Then
                    Utt1 = ut3(0) + ((ut5(0) - ut3(0)) / 2) * (K - 3)
                    Utt2 = ut3(1) + ((ut5(1) - ut3(1)) / 2) * (K - 3)
                    Ut = Utt2 + (((Utt1 - Utt2) / 20) * (ut0 - 731))
                ElseIf ut0 > 531 Then
                    Utt1 = ut3(1) + ((ut5(1) - ut3(1)) / 2) * (K - 3)
                    Utt2 = ut3(2) + ((ut5(2) - ut3(2)) / 2) * (K - 3)
                    Ut = Utt2 + (((Utt1 - Utt2) / 200) * (ut0 - 531))
                Else
                    Utt1 = ut3(2) + ((ut5(2) - ut3(2)) / 2) * (K - 3)
                    Ut = (Utt1 / 531) * ut0
                End If
            Case Else
                If ut0 > 751 Then
                    Ut = ut5(0)
                ElseIf ut0 > 731 Then
                    Ut = ut5(0) - (((ut5(0) - ut5(1)) / 20) * (751 - ut0))
                ElseIf ut0 > 531 Then
                    Ut = ut5(1) - (((ut5(1) - ut5(2)) / 200) * (731 - ut0))
                Else
                    Ut = (ut5(2) / 531) * ut0
                End If
        End Select
        'Facteur d'utilisation
        rendB = rend * Ut
        'Flux total des lampes en fonction du coefficient de dpreciation et de l'clairement demand
        flTot = (Ecl * (a * b) * d) / rendB
        'nbre thorique de luminaires ncessaires
        nblum1 = Fix(flTot / (nb * Flux))
        nbLum = CInt(nblum1) + 1
        'clairement moyen avec le nombre de luminaires rl
        EclMoy = (nbLum * nb * Flux) * rendB / ((a * b) * d)
        'writer de sortie du RTF
        Dim sw As New System.IO.StringWriter
        Dim msg, Note_de_Calcul, Fichier_NotedeCalcul, msgResult As String
        Dim Redacteur As String = "(A complter)"
        Dim Chantier As String = "(A complter)"
        'cre un writer de RTF avec une police par dfaut
        Dim rtf As New RtfAnsiTextWriter(sw, New Font(FontFamily.GenericSerif, 12, FontStyle.Regular))
        Dim rtff As String
        rtf.WriteStartGroup()
        rtf.NewParagraph(RtfAnsiTextWriter.Align.Center) : rtf.Bold = True : rtf.FontSize = 18 : rtf.Underline = True
        rtf.WriteString("Dimensionnement d'une installation d'clairage intrieur")
        rtf.NewLine()
        rtf.Bold = False : rtf.FontSize = 10 : rtf.Underline = False : rtf.NewParagraph(RtfAnsiTextWriter.Align.Left)
        rtf.WriteString("Note de calcul du : ") : msg = Mise_en_Forme_date(CStr(DateTime.Now)) : rtf.WriteString(msg) : rtf.NewLine()
        rtf.WriteString("Rdacteur : " & Redacteur) : rtf.NewLine()
        rtf.WriteString("Chantier : " & Chantier) : rtf.NewLine()
        rtf.WriteString("Logiciel : Eclairage  -  version 1.1  2006 - 2015") : rtf.NewLine()
        rtf.NewLine() : rtf.FontSize = 12 : rtf.Bold = True : rtf.Underline = True
        rtf.WriteString("1 - Rappel des hypothses") : rtf.Bold = False
        rtf.FontSize = 10 : rtf.Underline = False : rtf.NewLine() : rtf.NewLine()
        rtf.WriteString("Local " & local & " de " & a.ToString("#0.00") & " x " & b.ToString("#0.00") & " m avec h1 = " & h1.ToString("#0.00") & " m.") : rtf.NewLine()
        rtf.WriteString("Avec coefficient de rflexion plafond = " & Uplaf.ToString("#0.00") & " ; coefficient de rflexion mur = " & Umur.ToString("#0.00") & _
                        " ; coefficient de rflexion du plan utile = " & Uplanutile.ToString("#0.00")) : rtf.NewLine()
        rtf.WriteString("Coeffcient de dprciation : " & d.ToString("#0.00")) : rtf.NewLine()
        rtf.WriteString("L'clairage moyen demand, aprs application du coeffcient de dprciation, est de " & Ecl.ToString("#0") & " lux") : rtf.NewLine() : rtf.NewLine()
        rtf.FontSize = 12 : rtf.Bold = True : rtf.Underline = True
        rtf.WriteString("2 - Rsultats du calcul") : rtf.Bold = False
        rtf.FontSize = 10 : rtf.Underline = False : rtf.NewLine() : rtf.NewLine()
        rtf.WriteString(" Indice du local : " & K.ToString("#0.00")) : rtf.NewLine()
        rtf.WriteString(" Utilance du local : " & Ut.ToString("0.00")) : rtf.NewLine()
        rtf.WriteString(" Facteur d'utilisation (rendement global de l'installation): " & rendB.ToString("0.00")) : rtf.NewLine()
        rtf.WriteString(" Nombre total de luminaires : " & nbLum.ToString("###")) : rtf.NewLine()
        rtf.WriteString(" Eclairement moyen obtenu aprs dprciation : " & EclMoy.ToString("####.0") & " lux.") : rtf.NewLine()

        'gnre le RTF complet
        Note_de_Calcul = "Eclairage_" & Mise_en_Forme_date(CStr(DateTime.Now)) & ".rtf"
        msgResult = Directory.GetCurrentDirectory.ToString()
        Fichier_NotedeCalcul = msgResult & "\" & Note_de_Calcul
        rtf.Generate() : rtff = sw.ToString : File.WriteAllText(Fichier_NotedeCalcul, rtff)
        Dim Editeur As Integer = 1
        Try
            Select Case Editeur
                Case 1 'Editeur Interne
                    Dim frm1 As New frmEdit
                    frm1.Affichage_frmEdit(Fichier_NotedeCalcul)
                Case 2 'diteur Word
                    Dim SousDossier1 As String = My.Application.Info.DirectoryPath 'rpertoire dans lequel se trouve le logiciel Poutre BA
                    Dim startInfo As New ProcessStartInfo("word.exe") '("word.exe")
                    startInfo.WindowStyle = ProcessWindowStyle.Normal
                    startInfo.Arguments = Fichier_NotedeCalcul
                    Process.Start(startInfo.Arguments)
            End Select
        Catch ex As Exception

            msg = "Impossible d'afficher la note de calcul" & vbCrLf + "Exception: " + ex.Message & ex.StackTrace
            MsgBox(msg, MsgBoxStyle.Exclamation Or MsgBoxStyle.OkOnly, "Sub Calcul_Eclairage")
        End Try
    End Sub
    Private Function Mise_en_Forme_date(ByVal Toto As String) As String
        Dim toti As String
        toti = Replace(Toto, "/", "_")
        Toto = Replace(toti, " ", "_")
        toti = Replace(Toto, ":", "_")
        Mise_en_Forme_date = toti
    End Function
End Module
