Imports System.IO
Module Lecture
    'Lecture et criture du fichier de donnes
    Dim title As String = "Eclairage : module de lecture/criture"
    Dim style As MsgBoxStyle = MsgBoxStyle.Critical Or MsgBoxStyle.OKOnly

#Region " Code de lecture du fichier de donnes "

    Public Sub Lecture_fichier(ByRef Donnee_OK As Boolean)
        ' The StreamReader must be defined outside of the Try-Catch block
        '   in order to reference it in the Finally block.
        Dim myStreamReader As StreamReader
        Dim i, k As Integer
        Dim toto, msg As String
        Try
            Donnee_OK = True
            i = 1 : k = 1
            myStreamReader = File.OpenText(l_strFileName)
            toto = myStreamReader.ReadLine
            If toto <> "" Then Call titre(toto)
            While toto <> ""
                i = i + 1
                toto = myStreamReader.ReadLine
                If toto <> "" Then
                    Call Hypo(toto, k)
                    If Donnee_OK = False Then Exit Sub

                End If
            End While

        Catch exc As Exception
            ' Show the exception to the user.
            MsgBox("Fichier non compatible avec cette version logicielle" + vbCrLf + "Exception: " + exc.Message)
            Donnee_OK = False
        Finally
            ' Close the object if it has been created.
            If Not myStreamReader Is Nothing Then
                myStreamReader.Close()
            End If
        End Try
    End Sub

    Private Sub titre(ByVal toto As String)
        Dim i, position As Integer
        Dim msg As String
        toto = LCase(toto) 'transforme la chaine en minuscule, permet dans le fichier original d'crire en minuscule ou en majuscule
        toto = Trim(toto) 'supprime les espaces en debut et fin de chaine
        i = Len(toto)     'indique la longueur totale de la chaine
        position = InStr(toto, "eclairage") 'dtermine l'emplacement de robot
        If position = 0 Then
            msg = "Il manque l'entte Eclairage dans votre fichier."
            MsgBox(msg, style, title)
        End If
    End Sub

    Private Sub Hypo(ByVal toto As String, ByRef k As Integer)
        Dim blanc(15), i, j, position As Integer
        Dim titi(10), tutu As String
        toto = Trim(toto) 'supprime les espaces en debut et fin de chaine
        titi(1) = Microsoft.VisualBasic.Left(toto, 1)
        i = Len(toto)     'indique la longueur totale de la chaine
        'recherche de blanc dans la chaine
        j = 0 : blanc(1) = 1 : titi(1) = toto
        Do
            j = j + 1
            position = InStr(1, titi(j), " ") 'dtermine le nombre et la position des blanc 
            blanc(j) = position                      'dans la chaine
            tutu = titi(j)
            If position <> 0 Then
                titi(j) = Microsoft.VisualBasic.Left(tutu, position - 1)
                titi(j + 1) = Microsoft.VisualBasic.Right(tutu, i - position)
                titi(j + 1) = Trim(titi(j + 1))
                i = Len(titi(j + 1))
            End If
        Loop While blanc(j) <> 0

        Select Case k
            Case 1
                local = CStr(titi(1))
            Case 2 'ligne 2 du paragraphe hypothse
                If IsNumeric(titi(1)) = False Then Call Verification_point(titi(1))
                a = CDbl(titi(1)) : If IsNumeric(titi(2)) = False Then Call Verification_point(titi(2))
                b = CDbl(titi(2)) : If IsNumeric(titi(3)) = False Then Call Verification_point(titi(3))
                h1 = CDbl(titi(3))
            Case 3
                If IsNumeric(titi(1)) = False Then Call Verification_point(titi(1))
                Uplaf = CDbl(titi(1)) : If IsNumeric(titi(2)) = False Then Call Verification_point(titi(2))
                Umur = CDbl(titi(2)) : If IsNumeric(titi(3)) = False Then Call Verification_point(titi(3))
                Uplanutile = CDbl(titi(3))
            Case 4
                If IsNumeric(titi(1)) = False Then Call Verification_point(titi(1))
                d = CDbl(titi(1))
                Ecl = CInt(titi(2))
            Case 5
                nb = CInt(titi(1))
                Flux = CInt(titi(2)) : If IsNumeric(titi(3)) = False Then Call Verification_point(titi(3))
                rend = CDbl(titi(3))

        End Select

        k = k + 1
    End Sub

    Private Sub Verification_point(ByRef tata As String)
        Dim position As Integer
        position = InStr(1, tata, ".")
        If position <> 0 Then
            Mid(tata, position) = ","
        End If
    End Sub
#End Region

#Region " Code d'criture du fichier de donnes "
    Public Sub Ecriture_Fichier()
        ' The StreamWriter must be defined outside of the Try-Catch block
        '   in order to reference it in the Finally block.
        Dim myStreamWriter As StreamWriter
        Dim i, i5(3), i6(3), j As Integer
        ' Ensure that the creation of the new StreamWriter is wrapped in a 
        '   Try-Catch block, since an invalid filename could have been used.
        Try
            ' Create a StreamWriter using a Shared (static) File class.
            myStreamWriter = File.CreateText(l_strFileName)

            myStreamWriter.WriteLine("Eclairage")
            myStreamWriter.WriteLine(local)
            myStreamWriter.WriteLine(a & " " & b & " " & h1)
            myStreamWriter.WriteLine(Uplaf & " " & Umur & " " & Uplanutile)
            myStreamWriter.WriteLine(d & " " & Ecl)
            myStreamWriter.WriteLine(nb & " " & Flux & " " & rend)
            ' Flush the stream to ensure everything is flushed
            myStreamWriter.Flush()
        Catch exc As Exception
            MsgBox("File could not be opened or written to." + vbCrLf + _
                "Please verify that the filename is correct, " + _
                "and that you have read permissions for the desired " + _
                "directory." + vbCrLf + vbCrLf + "Exception: " + exc.Message)
        Finally
            ' Close the object if it has been created.
            If Not myStreamWriter Is Nothing Then
                myStreamWriter.Close()
            End If
        End Try
        'myStreamReader = File.OpenText(l_strFileName)

        'toto = myStreamReader.ReadLine
      
    End Sub
#End Region

End Module
