Imports System.ComponentModel
Imports System.IO
Imports System.Diagnostics

Public Class FrmEclairage

    Private Sub frmEclairage_Closing(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles MyBase.Closing
        Dim reponse As Integer
        reponse = MsgBox("Voulez-vous quitter l'application ?", MsgBoxStyle.YesNo Or MsgBoxStyle.Question Or MsgBoxStyle.DefaultButton1, "Eclairage")
        If reponse = 6 Then
            e.Cancel = False
            End
        Else
            e.Cancel = True
        End If
    End Sub

#Region " Gestion des menus"
    Private Sub mnuOuvrirProjet_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuOuvrirUnProjet.Click
        Dim donnee_OK As Boolean
        Dim Toto As String
        OpenFileDialog1.Title = "Ouvrir le projet"
        OpenFileDialog1.InitialDirectory = Directory.GetParent(Directory.GetCurrentDirectory).ToString() & "\data"
        OpenFileDialog1.Filter = "Fichiers textes (*.txt)|*.txt|Tous les fichiers (*.*)|*.*"
        OpenFileDialog1.FilterIndex = 1
        OpenFileDialog1.RestoreDirectory = True
        OpenFileDialog1.ShowDialog()
        If OpenFileDialog1.FileName <> "" Then
            Call Mise_a_zero_generale()    'mise  zro de toutes les variables publiques
            l_strFileName = OpenFileDialog1.FileName
            Toto = l_strFileName
            Call Lecture_chaine(Toto)
            Me.Text = "Eclairage : [ " & Toto & " ]"
            'si donnee_OK = TRUE, la lecture du fichier est correcte et le calcul peut continuer
            'sinon le calcul est arret.
            Call Lecture_fichier(donnee_OK)
            If donnee_OK = False Then Call Mise_a_zero_generale() 'r-initialisation  0 pour viter tout souci
        End If
    End Sub
    Private Sub Lecture_chaine(ByRef toto As String)
        'Traitement de la chaine de caractre pour pouvoir tre lu par le logiciel
        Try
            Dim i, position As Integer
            toto = Trim(toto) 'supprime les espaces en debut et fin de chaine
            i = Len(toto)     'indique la longueur totale de la chaine
            position = InStrRev(toto, "\")
            i = i - position
            toto = Microsoft.VisualBasic.Right(toto, i)
        Catch ex As Exception

        End Try

    End Sub
    Private Sub EnregistrerLeProjetSousToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles EnregistrerLeProjetSousToolStripMenuItem.Click
        Dim donnee_OK As Boolean = True
        'Call verification(donnee_OK)
        If donnee_OK = False Then Exit Sub
        SaveFileDialog1.Title = "Enregistrer le projet sous ..."
        SaveFileDialog1.InitialDirectory = Directory.GetParent(Directory.GetCurrentDirectory).ToString() & "\data"
        SaveFileDialog1.Filter = "Fichiers textes (*.txt)|*.txt|Tous les fichiers (*.*)|*.*"
        SaveFileDialog1.FilterIndex = 1
        SaveFileDialog1.RestoreDirectory = True
        SaveFileDialog1.ShowDialog()
        If SaveFileDialog1.FileName <> "" Then
            l_strFileName = SaveFileDialog1.FileName
            Call Ecriture_Fichier()
        End If
    End Sub
    'Private Sub mnuImprimer_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
    '    PrintDialog1.ShowDialog()
    'End Sub

    'Private Sub mnuConfig_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
    '    PageSetupDialog1.ShowDialog()
    'End Sub
    Private Sub mnuQuitter_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuQuitter.Click
        Dim reponse As Integer
        reponse = MsgBox("Voulez-vous quitter l'application ?", MsgBoxStyle.YesNo Or MsgBoxStyle.Question Or MsgBoxStyle.DefaultButton1, "Structure")
        If reponse = 6 Then
            '            J() 'ai un conseil pour que les diffrente Processus de cette mme appli soient automatiquement ferm au cas o :

            'Private Sub Me.OnClosing ...

            If (UBound(Diagnostics.Process.GetProcessesByName(Diagnostics.Process.GetCurrentProcess.ProcessName)) > 0) = True Then
                For Each ThisApp As Diagnostics.Process In Diagnostics.Process.GetProcessesByName(Diagnostics.Process.GetCurrentProcess.ProcessName)
                    ThisApp.Kill()
                Next
            End If
            Dim myProcesses() As Process
            Dim myProcess As Process
            myProcesses = Process.GetProcesses()
            For Each myProcess In myProcesses
                If UCase(myProcess.ProcessName) = "EXCEL" Then
                    myProcess.Kill()
                End If
            Next
            '    End Sub

            'Voil ! 
            'oki je suis d'accord mais ThisApp, tu le dclare en tanty ke koi???? "Object"????? Commentaire de : OneHacker le 01/05/2005 09:38:48  Non il est dclarer dans la ligne For Each...
            'Comme  As Diagnostics
            End
        End If
    End Sub
    Private Sub mnuProjet_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuProjet.Click
        Dim frmProjet1 As frmProjet
        frmProjet1 = New frmProjet
        frmProjet1.MdiParent = Me
        frmProjet1.Show()
    End Sub
    Private Sub mnuExecuter_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuExecuter.Click
        'Dim verif As Boolean
        'Call verification(verif)
        'If verif = False Then Exit Sub

        Call Calcul_Eclairage()
      
    End Sub
    Private Sub mnuAide_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuAide.Click
        Try
            'Dim SousDossier1 As String = My.Application.Info.DirectoryPath 'rpertoire dans lequel se trouve le logiciel Poutre BA
            'Dim startInfo As New ProcessStartInfo("AcroRd32.exe") '("word.exe")
            'startInfo.WindowStyle = ProcessWindowStyle.Normal
            'startInfo.Arguments = SousDossier1 & "\Aide_Eclairage.pdf"
            ' startInfo.Arguments = My.Resources.Aide_Eclairage
            Process.Start("bin\Aide_Eclairage.pdf")
        Catch ex As Exception
            Dim msg As String
            msg = "Impossible d'afficher l'Aide" & vbCrLf + "Exception: " + ex.Message & ex.StackTrace
            MsgBox(msg, MsgBoxStyle.Exclamation Or MsgBoxStyle.OkOnly, Me.Text)
        End Try

    End Sub
    Private Sub mnuAProposDe_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuAProposDe.Click
        Dim frmsplash1 As frmSplash
        frmsplash1 = New frmSplash
        frmsplash1.ShowDialog()
    End Sub
#End Region


End Class
